import collections
import socket
import subprocess

import charmhelpers.core.hookenv as hookenv
import charms_openstack.charm
import charms_openstack.ip as os_ip

# import charms_openstack.sdn.odl as odl
# import charms_openstack.sdn.ovs as ovs

def check_nic(nic):
    try:
        subprocess.check_output(["ifconfig", nic], shell=False)
        return True
    except subprocess.CalledProcessError:
        return False

class UcarpCharm(charms_openstack.charm.OpenStackCharm):

    def assess_status(self):
        pass

    # Internal name of charm
    service_name = name = 'carp'

    # First release supported
    release = 'mitaka'

    # List of packages to install for this charm
    packages = ['ucarp', 'python-apt']

#    api_ports = {
#        'ucarp': {
#            os_ip.PUBLIC: 80,
#            os_ip.ADMIN: 80,
#            os_ip.INTERNAL: 80,
#        }
#    }

    service_type = 'ucarp'
    default_service = 'ucarp'
    services = ['networking']

    # Note that the hsm interface is optional - defined in config.yaml
#    required_relations = ['magpie']

    restart_map = {

        '/etc/network/interfaces.d/ucarp_interface.cfg': services,
        '/etc/network/if-up.d/ucarp': services,
    }

    # ha_resources = ['vips', 'haproxy']

    release_pkg = 'ucarp-common'

    package_codenames = {
        'ucarp-common': collections.OrderedDict([
            ('2', 'mitaka'),
            ('3', 'newton'),
            ('4', 'ocata'),
        ]),
    }
